// -*- C++ -*-
/*!
 * @file CreateComp.cpp
 *
 */

#include <rtm/Manager.h>
#include <iostream>
#include <string>
#include <rtm/NVUtil.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>


void MyModuleInit(RTC::Manager* manager)
{
  RTC::RtcBase* comp;

  char szDir[256];

#warning "Absolute path?"
  strcpy(szDir, "/home/openrtm/sample/MyServiceA/MyServiceProviderA.so");
  manager->load(szDir, "MyServiceProviderAInit");

  strcpy(szDir, "/home/openrtm/sample/MyServiceB/MyServiceProviderB.so");
  manager->load(szDir, "MyServiceProviderBInit");

  for (int j=0; j<2; j++){
      // Create a component
      if (j == 0){
          std::cout << "Creating a component: \"MyServiceA\"....";
          comp = manager->createComponent("MyServiceProviderA");
          std::cout << "succeed." << std::endl;
      } else {
          std::cout << "Creating a component: \"MyServiceB\"....";
          comp = manager->createComponent("MyServiceProviderB");
          std::cout << "succeed." << std::endl;
      }
      sleep(1);

      RTC::ComponentProfile_var prof;
      prof = comp->get_component_profile();
      std::cout << "=================================================" << std::endl;
      std::cout << " Component Profile" << std::endl;
      std::cout << "-------------------------------------------------" << std::endl;
      std::cout << "InstanceID:     " << prof->instance_name << std::endl;
      std::cout << "Implementation: " << prof->type_name << std::endl;
      std::cout << "Description:    " << prof->description << std::endl;
      std::cout << "Version:        " << prof->version << std::endl;
      std::cout << "Maker:          " << prof->vendor << std::endl;
      std::cout << "Category:       " << prof->category << std::endl;
      std::cout << "  Other properties   " << std::endl;
      NVUtil::dump(prof->properties);
      std::cout << "=================================================" << std::endl;
    }
  return;
}

int main (int argc, char** argv)
{
  RTC::Manager* manager;
  manager = RTC::Manager::init(argc, argv);

  // Initialize manager
  manager->init(argc, argv);

  manager->setModuleInitProc(MyModuleInit);

  // Activate manager and register to naming service
  manager->activateManager();

  // run the manager in blocking mode
  // runManager(false) is the default.
  manager->runManager();

  // If you want to run the manager in non-blocking mode, do like this
  // manager->runManager(true);

  return 0;
}
