// -*- C++ -*-
/*!
 * @file  MyServiceProviderA.cpp
 * @brief MyService Provider Sample component
 * $Date$
 *
 * $Id$
 */

#include "MyServiceProviderA.h"

// Module specification
// <rtc-template block="module_spec">
static const char* myserviceprovidera_spec[] =
  {
    "implementation_id", "MyServiceProviderA",
    "type_name",         "MyServiceProviderA",
    "description",       "MyService Provider Sample component",
    "version",           "0.1",
    "vendor",            "AIST",
    "category",          "Generic",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

MyServiceProviderA::MyServiceProviderA(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_MyServiceAPort("MyServiceA"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  m_MyServiceAPort.registerProvider("myservicea0", "MyService", m_myservicea0);
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  registerPort(m_MyServiceAPort);
  
  // </rtc-template>

}

MyServiceProviderA::~MyServiceProviderA()
{
}


RTC::ReturnCode_t MyServiceProviderA::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t MyServiceProviderA::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderA::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void MyServiceProviderAInit(RTC::Manager* manager)
  {
    RTC::Properties profile(myserviceprovidera_spec);
    manager->registerFactory(profile,
                             RTC::Create<MyServiceProviderA>,
                             RTC::Delete<MyServiceProviderA>);
  }
  
};


