// -*- C++ -*-
/*!
 * @file  MyServiceProviderB.cpp
 * @brief MyService Provider Sample component
 * $Date$
 *
 * $Id$
 */

#include "MyServiceProviderB.h"

// Module specification
// <rtc-template block="module_spec">
static const char* myserviceproviderb_spec[] =
  {
    "implementation_id", "MyServiceProviderB",
    "type_name",         "MyServiceProviderB",
    "description",       "MyService Provider Sample component",
    "version",           "0.1",
    "vendor",            "AIST",
    "category",          "Generic",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

MyServiceProviderB::MyServiceProviderB(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_MyServiceBPort("MyServiceB"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  m_MyServiceBPort.registerProvider("myserviceb0", "MyService", m_myserviceb0);
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  registerPort(m_MyServiceBPort);
  
  // </rtc-template>

}

MyServiceProviderB::~MyServiceProviderB()
{
}


RTC::ReturnCode_t MyServiceProviderB::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t MyServiceProviderB::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MyServiceProviderB::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void MyServiceProviderBInit(RTC::Manager* manager)
  {
    RTC::Properties profile(myserviceproviderb_spec);
    manager->registerFactory(profile,
                             RTC::Create<MyServiceProviderB>,
                             RTC::Delete<MyServiceProviderB>);
  }
  
};


